using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceInvadersPhone
{
    class Barrier
    {
        // Texture representing the barrier blocks
        public Texture2D BarrierTexture;

        // Position of the laser relative to the upper left side of the screen
        public Vector2 Position;

        // State of the laser
        public bool Active;

        //Represents the viewable boundary of the game window
        Viewport viewport;

        public Rectangle barrierRect;

        public int barrierHealth;

        //Get the width of the player ship
        public int Width
        {
            get { return BarrierTexture.Width; }
        }

        //Get the height of the player ship
        public int Height
        {
            get { return BarrierTexture.Height; }
        }

        public void Initialize(Viewport viewport, Texture2D texture, Vector2 position)
        {
            BarrierTexture = texture;
            Position = position;
            this.viewport = viewport;
            Active = true;
            barrierHealth = 3;

            //This code will scale the barrier blocks based on the size of the screen the user has
            float barrierAspectRatio = (float)BarrierTexture.Width / BarrierTexture.Height;

            float barrierrWidth = (float)viewport.Width / 35;

            float barrierHeight = barrierrWidth / barrierAspectRatio;           

            barrierRect = new Rectangle((int)Position.X, (int)Position.Y, (int)barrierrWidth, (int)barrierHeight);
        }

        public void Update(int health)
        {
            if (health == 0)
            {
                Active = false;
            }

        }

        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(BarrierTexture, barrierRect, Color.White);
        }
    }
}
