using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Collections.Generic;

namespace SpaceInvadersPhone
{
    class PlayScreen
    {
        public Texture2D ScreenBorder;

        public Rectangle borderRect;

        public Vector2 txtPos, txtPos1, txtPos2;

        Viewport view;

        public void Initialize(Texture2D border, Viewport viewport)
        {
            ScreenBorder = border;
            view = viewport;

            //Position of the number of lives text            
            txtPos.X = 0;
            txtPos.Y = 0;

            //Position of player score           
            txtPos1.X = (int)(viewport.Width / (float)1.3);
            txtPos1.Y = 0;

            txtPos2.X = (int)(viewport.Width / (float)2.4);
            txtPos2.Y = 0;

            borderRect = new Rectangle(0, view.Height / 12, view.Width, view.Height / 200);
        }

        /// <summary>
        /// Draw the number of lives remaining to the game screen
        /// </summary>
        /// <param name="spriteBatch"></param>
        /// <param name="font"></param>
        public void DrawLives(SpriteBatch spriteBatch, SpriteFont font, int Lives)
        {
            //Display number of lives
            spriteBatch.DrawString(font, "Lives " + Lives, txtPos, Color.White);
        }

        /// <summary>
        /// Draw the score to the game screen
        /// </summary>
        /// <param name="spriteBatch"></param>
        /// <param name="font"></param>
        public void DrawScore(SpriteBatch spriteBatch, SpriteFont font, int Score)
        {
            //Display score
            spriteBatch.DrawString(font, "Score " + Score, txtPos1, Color.White);
        }

        /// <summary>
        /// Draw the current round number the player is on to the game screen
        /// </summary>
        /// <param name="spriteBatch"></param>
        /// <param name="font"></param>
        public void DrawRound(SpriteBatch spriteBatch, SpriteFont font, int Round)
        {
            spriteBatch.DrawString(font, "Round " + Round, txtPos2, Color.White);
        }

        public void DrawBorder(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(ScreenBorder, borderRect, Color.White);
        }
    }
}
