using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceInvadersPhone
{
    public class PowerUp
    {
        //These are all of the power up textures used 
        public Texture2D powerTextureShield, powerTextureMovement, powerTextureDouble;

        public Vector2 Position;

        public bool dropPowerActive;

        public Rectangle powerRect;

        //Get the width of the power up texture
        public int powerUpShieldWidth
        {
            get { return powerTextureShield.Width; }
        }

        //Get the height of the power up texture
        public int powerUpShieldHeight
        {
            get { return powerTextureShield.Height; }
        }

        //Get the width of the power up texture for movement
        public int powerUpMovementWidth
        {
            get { return powerTextureMovement.Width; }
        }

        //Get the height of the power up texture for movement
        public int powerUpMovementHeight
        {
            get { return powerTextureMovement.Height; }
        }

        //Get the width of the power up texture for movement
        public int powerUpDoubleWidth
        {
            get { return powerTextureDouble.Width; }
        }

        //Get the height of the power up texture for movement
        public int powerUpDoubleHeight
        {
            get { return powerTextureDouble.Height; }
        }

        Viewport viewport;

        public Rectangle powerUpShieldRect, powerUpMovementRect, powerUpDoubleRect;

        int dropSpeed;

        public int Type;

        //I think I will need to parse an isntance of the player to be able
        //to modify its values with a power up

        public void InitialisePowerUps(Texture2D powerUpShield, Texture2D powerUpMovement, Texture2D powerUpDouble, Viewport viewport, Vector2 position, int type)
        {
            powerTextureShield = powerUpShield;
            powerTextureMovement = powerUpMovement;
            powerTextureDouble = powerUpDouble;
            this.viewport = viewport;
            Position = position;
            Type = type;
            dropSpeed = 2;
            dropPowerActive = true;

            switch (type)
            {
                //If the power up required is for shields then create a new shield rectangle
                case 1:
                    powerTextureShield = powerUpShield;

                    float shieldPowerUpAspectRatio = (float)powerUpShieldWidth / powerUpShieldHeight;
                    float shieldPowerWidth = (float)viewport.Width / 100;
                    float shieldPowerHeight = powerUpShieldWidth / shieldPowerUpAspectRatio;

                    powerUpShieldRect = new Rectangle((int)Position.X, (int)Position.Y, (int)shieldPowerWidth, (int)shieldPowerHeight);
                    break;

                case 2:

                    powerTextureMovement = powerUpMovement;

                    float movementAspectRatio = (float)powerUpMovementWidth / powerUpMovementHeight;
                    float movementWidth = (float)viewport.Width / 100;
                    float movementHeight = movementWidth / movementAspectRatio;

                    powerUpMovementRect = new Rectangle((int)Position.X, (int)Position.Y, (int)movementWidth, (int)movementHeight);
                    break;

                case 3:

                    powerTextureDouble = powerUpDouble;

                    float doubleAspectRatio = (float)powerUpDoubleWidth / powerUpDoubleHeight;
                    float doubleWidth = (float)viewport.Width / 100;
                    float doubleHeight = doubleWidth / doubleAspectRatio;

                    powerUpDoubleRect = new Rectangle((int)Position.X, (int)Position.Y, (int)doubleWidth, (int)doubleHeight);
                    break;
            }
        }

        /// <summary>
        /// Update the power up's current position and time remaining
        /// </summary>
        /// <param name="position">Position of the forcefield relative to the player</param>
        /// <param name="current"></param>
        /// <param name="powerUp">The forcefield object</param>
        public void UpdatePowerUp(int i)
        {
            switch (i)
            {
                case 1:

                    powerUpShieldRect.Y += dropSpeed;
                    break;

                case 2:

                    powerUpMovementRect.Y += dropSpeed;
                    break;

                case 3:

                    powerUpDoubleRect.Y += dropSpeed;
                    break;
            }
        }

        public void DrawPowerUp(SpriteBatch spriteBatch, int powerUpType)
        {
            switch (powerUpType)
            {
                //If the power up required is for shields then create a new shield rectangle
                case 1:

                    spriteBatch.Draw(powerTextureShield, powerUpShieldRect, Color.White);
                    break;

                case 2:

                    spriteBatch.Draw(powerTextureMovement, powerUpMovementRect, Color.White);
                    break;

                case 3:

                    spriteBatch.Draw(powerTextureDouble, powerUpDoubleRect, Color.White);
                    break;
            }
        }
    }
}
